

namespace Examples

variable {α : Sort u} {β : α → Sort v}

abbrev pointwiseEq (f g : (x : α) → β x) : Prop :=
  ∀ (x : α), f x = g x

infix:50 " ~ " => pointwiseEq

variable {f g : (x : α) → β x}

def extfunApp
    (f : @Quot ((x : α) → β x) (· ~ ·)) (x : α) : β x :=
  f.lift
    (fun (f : ∀ (x : α), β x) => f x)
    (fun _ _ h => h x)

#reduce extfunApp (Quot.mk (· ~ ·) f)

theorem funext (h : f ~ g) : f = g := by
  show extfunApp (Quot.mk (· ~ ·) f) = extfunApp (Quot.mk (· ~ ·) g)
  rewrite [Quot.sound h]
  rfl
