def gtFive (n : Nat) : Option Nat :=
  if n > 5 then some n else none

def hasLength (len : Nat) (str : String) : Option String :=
  if str.length = len then some str else none

-- Check that the desired length is big enough, and that the string is
-- that long, then return the string with a tag
def validate (n : Nat) (str : String) : Option String := do
  let n' ← gtFive n
  let str' ← hasLength n' str
  pure ("It is: " ++ str')

inductive Tree (α : Type) where
  | leaf
  | branch : Tree α → α → Tree α → Tree α

-- def number : Tree α → Tree (Nat × α) := sorry

def numberFrom (n : Nat) : Tree α → (Tree (Nat × α) × Nat)
  | .leaf => (.leaf, n)
  | .branch l x r =>
    let (l', n') := numberFrom n l
    let v := (n', x)
    let (r', n'') := numberFrom (n' + 1) r
    (.branch l' v r', n'')

def number (t : Tree α) := (numberFrom 0 t).fst

def number' (t : Tree α) := ((helper t).run 0).fst
where
  helper : Tree α → StateT Nat Id (Tree (Nat × α))
    | .leaf => pure .leaf
    | .branch l x r => do
      return .branch (← helper l) (← get, x) (← helper r)

def main : IO Unit := IO.println "Hello, world!"
