-- See Abel and Coquand '20 for details
namespace Norm1

def False := ∀(P : Prop), P

def Not (P : Prop) := P → False

def True := Not False

def δ : True := fun (z : False) =>
  -- Take a proof of false and apply it to itself
  z True z

-- Not all propositions are equal
def ω : Not (∀ (a b : Prop), a = b) :=
  fun (h : ∀(a b : Prop), a = b) (a : Prop) =>
    -- Here we cast from True to a in δ
    (h True a) ▸ δ

def Ω : Not (∀ (a b : Prop), a = b) :=
  fun h => δ (ω h)

-- #reduce Ω

end Norm1

namespace Norm2

-- All true propositions are equivalent
def tautext {A B : Prop} (a : A) (b : B) : A = B := by
  apply propext
  constructor <;> intros <;> assumption

def True : Prop := ∀(P : Prop), P → P

def δ : True → True := fun (z : True) =>
  -- z (True → True) : (True → True) → (True → True)
  -- z (True → True) id : True → True
  z (True → True) id z

def ω : True := fun (P : Prop) (p : P) =>
  -- P is some true proposition, and `id` proves `True`, so
  -- `tautext id p` proves that True = P.
  tautext id p ▸ δ

def Ω : True := δ ω

-- #reduce Ω

end Norm2
