namespace TypeClasses
/-
typeclass instance problem is stuck, it is often due to metavariables
  HAdd ?m.21 (?m.9 x) (?m.10 x y)
-/
-- def add x y := x + y

def add [Add α] (x y : α) : α :=
  x + y

instance : HAdd String Nat String where
  hAdd x y := x ++ toString y

#eval "hello " + 5

namespace Structures

structure Monoid (α : Type) where
  neutral : α
  op : α → α → α

def additive : Monoid Nat where
  neutral := 0
  op := (· + ·)

def multiplicative : Monoid Nat where
  neutral := 1
  op := (· * ·)

def Monoid.evalList (mon : Monoid α) : List α → α
  | [] => mon.neutral
  | x :: xs => mon.op x (mon.evalList xs)

#eval additive.evalList [1,2,3,4]
#eval multiplicative.evalList [1,2,3,4]

end Structures

class Monoid (α : Type) where
  neutral : α
  op : α → α → α

instance additive : Monoid Nat where
  neutral := 0
  op := (· + ·)

instance multiplicative : Monoid Nat where
  neutral := 1
  op := (· * ·)

def evalList [Monoid α] : List α → α
  | [] => Monoid.neutral
  | x :: xs => Monoid.op x (evalList xs)

#eval evalList [1,2,3,4]
#eval @evalList _ additive [1,2,3,4]


structure Pos where
  succ ::
  pred : Nat
deriving Repr

def one : Pos := .succ 0

instance : Add Pos where
  add n k := ⟨n.pred + k.pred + 1⟩

def two : Pos := one + one
#eval two

instance : OfNat Pos (n + 1) where
  ofNat := .succ n

#eval (1 : Pos)

instance : ToString Pos where
  toString
    | .succ n => toString (n + 1)

#eval toString ((5 : Pos) + 5)
